# -*- coding: utf-8 -*-
"""
Created on Tue Apr 17 22:10:07 2018

@author: lenovo
"""

def wgn(x,snr):
    snr = 10**(snr/10.0)
    xpower = np.sum(np.sum(x**2))/len(x)
    npower = xpower / snr
    return np.random.randn(len(x)) * np.sqrt(npower)

import numpy as np
from numpy import loadtxt
from sklearn.ensemble import RandomForestClassifier

import time
start_time = time.time()

train = loadtxt('zonghe3train.csv', delimiter=",")
tests = loadtxt('zonghe3test.csv', delimiter=",")

X_train = train[:,0:54]
Y_train = train[:,54]
tests = tests[:,0:54]

snr = 50
for i in range(len(X_train[0])):
    n_train=wgn(X_train[:,i],snr)
    a_train=np.array(X_train[:,i])
    n_train=np.array(n_train)
    X_train[:,i]= a_train + n_train

for i in range(len(tests[0])):
    n_tests=wgn(tests[:,i],snr)
    a_tests=np.array(tests[:,i])
    n_tests=np.array(n_tests)
    tests[:,i]= a_tests + n_tests

clf = RandomForestClassifier(n_estimators=10)
clf.fit(X_train,Y_train)
predicts = clf.predict(tests)