# -*- coding: utf-8 -*-
"""
Created on Sun May  6 02:55:18 2018

@author: lenovo
"""


"""
Created on Tue Apr 17 22:10:07 2018

@author: lenovo

def wgn(x,snr):
    snr = 10**(snr/10.0)
    xpower = np.sum(np.sum(x**2))/len(x)
    npower = xpower / snr
    return np.random.randn(len(x)) * np.sqrt(npower)
"""

import numpy as np
import pandas as pd
import xgboost as xgb
import time
import pywt
from sklearn import preprocessing
now = time.time()

XX_train = pd.read_csv('3-zonghetrain3-2.csv')
YY_train = pd.read_csv('3-zonghetrain3-2-1.csv')
testss = pd.read_csv('3-zonghetest3-2.csv')
offset = 12000
XX_scaled = preprocessing.scale(XX_train)
X_train = pywt.threshold(XX_scaled.values, 2, 'soft',6)
Y_train = YY_train.values
tests = testss.values

"""

snr = 30
for i in range(2,len(X_train[0])):
    n_train=wgn(X_train[:,i],snr)
    a_train=np.array(X_train[:,i])
    n_train=np.array(n_train)
    X_train[:,i]= a_train + n_train

for i in range(2,len(X_val[0])):
    n_val=wgn(X_val[:,i],snr)
    a_val=np.array(X_val[:,i])
    n_val=np.array(n_val)
    X_val[:,i]= a_val + n_val

for i in range(2,len(tests[0])):
    n_tests=wgn(tests[:,i],snr)
    a_tests=np.array(tests[:,i])
    n_tests=np.array(n_tests)
    tests[:,i]= a_tests + n_tests

"""
xgb_train = xgb.DMatrix(X_train[:offset,:], label=Y_train[:offset])
xgb_val = xgb.DMatrix(X_train[offset:,:], label=Y_train[offset:])
xgb_test = xgb.DMatrix(tests)
params={
'booster':'gbtree',
'objective': 'multi:softmax', #多分类的问题
'eval_metric': 'auc',
'num_class':3,
    'max_depth':8,
    'lambda':100,
    'subsample':0.75,
    'colsample_bytree':0.75,
    'min_child_weight':2,
    'eta': 0.025,
    'seed':0,
    'nthread':8,
     'silent':1
}
plst = list(params.items())
num_rounds = 5000 # 迭代次数
watchlist = [(xgb_train, 'train'),(xgb_val, 'val')]


model = xgb.train(plst, xgb_train, num_rounds, watchlist,early_stopping_rounds=100)
model.save_model('xgb.model') # 用于存储训练出的模型
print("best best_ntree_limit",model.best_ntree_limit )

cost_time = time.time()-now
print("end ......",'\n',"cost time:",cost_time,"(s)......")
preds = model   .predict(xgb_test,ntree_limit=model.best_iteration)

np.savetxt('xgb_submission1.csv',np.c_[range(1,len(tests)+1),preds],delimiter=',',header='ImageId,Label',comments='',fmt='%d')

